#!/usr/bin/python

import websocket
import struct
import time
import sys
import math
from threading import Timer
import logging



VIRUS=2
NORMAL=1

class DOT(object):

	def __init__(self,name,idd):
		self.idd=idd
		self.name=name
		self.idd
		self._lasttime=time.time()
		self._velocity=0.0
		self._direction=(0.0,0.0)
		self._x=None
		self._y=None
	def __repr__(self):
		return "name: %s" % self.name.__repr__() + \
			" area: %s" % self.area.__repr__() + \
			" size: %s" % self.size.__repr__() + \
			" x: %s" % self.x.__repr__() + \
			" y: %s" % self.y.__repr__()

	@property
	def velocity(self):
		return self._velocity

	@property
	def direction(self):
		return self._direction

	@property
	def area(self):
		#return self.size**2*math.pi
		return self.size**2
	@area.setter
	def area(self,value):
		#self.size=(value/math.pi)**.5
		self.size=(value)**.5

	def get_pos(self):
		return (self.x, self.y)

	def set_pos(self, value):
		(x,y)=value
		if (not self._x == None) and (not self._y == None) \
				and (not x == None) and (not y == None):
			self._velocity=((x-self._x)**2+(y-self._y)**2)**.5
			if self._velocity==0.0:
				self._direction=(0.0,0.0)
			else:
				direction=((x-self._x)/self._velocity, (y-self._y)/self._velocity)
				self._velocity =  self._velocity/(time.time()-self.lasttime)

				self._direction=direction
		self._x = x
		self._y = y
	pos = property(get_pos, set_pos)

	def get_x(self):
		return self._x
	def set_x(self, value):
		self._x = value
	x = property(get_x, set_x)

	def get_y(self):
		return self._y
	def set_y(self, value):
		self._y = value
	y = property(get_y, set_y)

	@property
	def size(self):
		return self._size
	@size.setter
	def size(self, value):
		self._size = value

	@property
	def lasttime(self):
		return self._lasttime
	@lasttime.setter
	def lasttime(self, value):
		self._lasttime = value

	def dist(self,x,y):
		return math.sqrt((self.x-x)**2+(self.y-y)**2)

class GAME():
	def moveto(self,x,y):
		if (self.lastmovetox==x and self.lastmovetox==y):
			return
#		self.prevVect=(x-self.lastmovetoy, self.lastmovetoy)
#		dist=(self.prevVect[0]**2+self.prevVect[1]**2)**.5
#		self.prevVectNorm=(self.prevVect[0]/dist, self.prevVect[1]/dist)
		self.lastmovetox=x
		self.lastmovetoy=y
		self.ws.send(struct.pack("=BddI",16,float(x),float(y),0),0x2)
	def setplayer(self,name):
		self.ws.send("\x00"+name.encode("utf-16")[2:],0x2)
	def emit(self,x):
		self.ws.send(struct.pack("B",x),0x2)
	def quit(self):
		self.ws.close()
		if self.splitTimer:
			self.splitTimer.cancel()
		if self.shootTimer:
			self.shootTimer.cancel()
		sys.exit(1)
	def spectating(self):
		self.emit(1)
	def doSplitAllow(self):
		self.splitAllow=True
	def split(self):
		#self.emit(17)
		if self.splitAllow:
			self.splitAllow=False
			self.splitTimer=Timer(self.splitTimerTime,self.doSplitAllow,())
			self.splitTimer.start()
			self.emit(17)
	def doShootAllow(self):
		self.shootAllow=True
	def shoot(self):
		if self.shootAllow:
			self.shootAllow=False
			self.shootTimer=Timer(self.shootTimerTime,self.doShootAllow,())
			self.shootTimer.start()
			self.emit(21)
	def __on_message__(self, ws, message):
		def c(ws,message):
			for x in self.dots.values():
				if not x.realaway:
         				x.lasttime=time.time()
					x.active=True

			l=1
			(pids,)=struct.unpack("H",message[l:l+2])
			l+=2

			for i in xrange(pids):
				(pid1,)=struct.unpack("I",message[l:l+4])
				l+=4
				(pid2,)=struct.unpack("I",message[l:l+4])
				l+=4

			while True:
				(pid,)=struct.unpack("I",message[l:l+4])
				l+=4
				if pid==0:
					break
				(pointX,pointY,pointSize,Cred,Cgreen,Cblue,m3)=struct.unpack("HHHBBBB",message[l:l+10])
				l+=10
				if bool (m3 & 1):
					pointType=VIRUS
				else:
					pointType=NORMAL
				if m3 & 2 : l+=4
				if m3 & 4 : l+=8
				if m3 & 8 : l+=16

				pointName=u""
				while(True):
					(c,)=struct.unpack("H",message[l:l+2])
					l+=2
					if c!=0:
						pointName+=unichr(c)
					else:
						break


				if not self.dots.has_key(pid):
					self.dots[pid]=DOT(pointName,pid)
				D=self.dots[pid]
				#D.x=pointX
				#D.y=pointY
				D.pos=(pointX, pointY)
				D.lasttime=time.time()
				D.realaway=False
				D.size=pointSize
				D.color=(Cred,Cgreen,Cblue)
				D.type=pointType
				D.active=True

			(lifes,)=struct.unpack("I",message[l:l+4])
			l+=4
			for x in xrange(lifes):
				(pik,)=struct.unpack("I",message[l:l+4])
				if self.dots.has_key(pik):
					self.dots[pik].lasttime=time.time()
					self.dots[pik].realaway=True
					self.dots[pik].active=False
				l+=4

			for x in self.dots.keys():
				if self.dots[x].lasttime<time.time()-60:
					del self.dots[x]

			x=0.0
			y=0.0
			counter=0
			for i in self.myids:
				if self.dots.has_key(i) and self.dots[i].active==True:
					counter+=1
					x+=self.dots[i].x
					y+=self.dots[i].y
				else:
					del self.myids[self.myids.index(i)]
			if counter!=0:
				self.gamecenter = x/counter,y/counter
			#self.logger.debug("%s %s" % (time.time(), [(i ,self.dots[i].area) for i in self.myids].__repr__()))
# MEASURE
			line=""
			line+=("(%2.6f, [" % time.time())
			for i in self.myids:
				line+=" ( %d" % i
				line+=", %8.6f" % self.dots[i].area
				line+=", %8.6f" % self.dots[i].x
				line+=", %8.6f )," % self.dots[i].y
			line+="])"
			if len(self.myids) >0:
				self.logger.debug("MEASURE : %s",line)
#			if self.split_time_measure != None and counter==1:
#				self.merge_time_measure=time.time()
#				self.split_time_measure=None
#				self.logger.debug("merge time %s, mass %f" % (self.merge_time_measure, self.dots[self.myids[0]].area))
#			if counter == 2 and self.split_time_measure != None:
#				self.split_time_measure=time.time()
#				self.logger.debug("split time %s, mass: %s" % (self.split_time_measure, [self.dots[i].area for i in self.myids].__repr__()))

			self.render()
		def a(ws,message):
			(self.gleft,self.gbottom,self.gright,self.gtop)=struct.unpack("dddd",message[1:])
			self.gamecenter = (self.gright-self.gleft)/2.0,(self.gtop-self.gbottom)/2.0
		def b(ws,message):
			self.topplayers=[]
			(counter,) = struct.unpack("I",message[1:5])
			l=5
			for i in xrange(counter):
				pid=struct.unpack("I",message[l:l+4])
				l+=4
				playername=""
				c=1
				while(c!=0):
					(c,)=struct.unpack("H",message[l:l+2])
					if c!=0:
						playername+=unichr(c)
					l+=2
				if playername=="":
					playername="An unnamed cell"
				self.topplayers.append({
				'id': pid,
				'name': playername
				});
		def e(ws,message):
			self.myids.append(struct.unpack("I",message[1:5])[0])
		def d(ws,message):
			(x,y,L)=struct.unpack("fff",message[1:25])
			self.gamecenter = x,y
		parse_case={
			64 : a,
			49 : b,
			16 : c,
			17 : d,
			32 : e,
		}
		if parse_case.has_key(ord(message[0])):
			parse_case[ord(message[0])](ws,message)
		else:
			print "Unknown message: ",ord(message[0]),len(message),[hex(ord(i)) for i in message],message



	def __on_close__(self,ws):
		#ws.send("\x00"+u"byebye".encode("utf-16"))
		#ws.close()
#		self.logger.info("Close")
		pass
	def __on_error__(self,ws, error):
		self.ws.send("\x00"+u"byebye".encode("utf-16"),0x2)
		raise Exception(error)

	def __on_open__(self,ws):
		ws.send(struct.pack("=BI",254,1),0x2)
		ws.send(struct.pack("=BI",255,1),0x2)
		return

	def __init__(self,ws,DEBUG=False):
		self.lastsplit=time.time()
		self.lastshott=time.time()
		self.debug=DEBUG
		self.topplayers=[]
		self.lastmovetox=-50.0
		self.lastmovetoy=-50.0
		self.dots={}
		self.myids=[]
		if self.debug:
			websocket.enableTrace(True)
		self.wsurl="ws://"+ws+"/"
		self.ws = websocket.WebSocketApp(
			self.wsurl,
			on_message = self.__on_message__,
			on_error = self.__on_error__,
			on_close = self.__on_close__,
			on_open= self.__on_open__,
			header = [
				"Sec-WebSocket-Extensions: permessage-deflate; client_max_window_bits",
				"Pragma: no-cache",
				"User-Agent: Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/42.0.2311.90 Safari/537.36"
				]
		)
		self.splitTimer=None
		self.splitTimerTime=1
		self.splitAllow=True
		self.shootTimer=None
		self.shootTimerTime=.05
		self.shootAllow=True
		self.prevDots={}
		self.prevPos=(0.0,0.0)
		self.prevMoveVect=(0.0,0.0)
		self.prevVect=(0.0,0.0)
		self.prevVectNorm=(0.0,0.0)
		self.logger = logging.getLogger(__name__)
		self.logger.setLevel(logging.DEBUG)
		self.split_time_measure=None
		self.merge_time_measure=None

	def start(self):
		self.ws.run_forever(origin="http://agar.io")

